﻿
assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRALItem")

-- DO NOT translate these, use the locale tables below
local reagents = {
	PRIEST = "SacredCandle",
	MAGE = "ArcanePowder",
	DRUID = "WildThornroot",
	WARLOCK = "SoulShard",
	SHAMAN = "Ankh",
	PALADIN = "SymbolofDivinity",
	ROGUE = "FlashPowder",
}

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["itemleader"] = true,
	["item"] = true,
	["Options for item checks."] = true,
	["SacredCandle"] = "Sacred Candle",
	["ArcanePowder"] = "Arcane Powder",
	["WildThornroot"] = "Wild Thornroot",
	["Ankh"] = "Ankh",
	["SymbolofDivinity"] = "Symbol of Divinity",
	["FlashPowder"] = "Flash Powder",
	["SoulShard"] = "Soul Shard",
	["Checks Disabled"] = true,
	["Items"] = true,
	["Reagents"] = true,
	["Close"] = true,
	["Refresh"] = true,
	["Name"] = true,
	["Item"] = true,
	["Amount"] = true,
	["Nr"] = true,
	["Perform item check"] = true,
	["Check the raid for an item."] = true,
	["<item>"] = true,
	["Perform reagent check"] = true,
	["Check the raid for reagents."] = true,
	["check"] = true,
	["reagent"] = true,
	["Leader/Item"] = true,
} end )

L:RegisterTranslations("koKR", function() return {
	["Options for item checks."] = "아이템 확인 설정",
	["SacredCandle"] = "성스러운 양초",
	["ArcanePowder"] = "불가사의한 가루",
	["WildThornroot"] = "야생 가시",
	["Ankh"] = "십자가",
	["SymbolofDivinity"] = "신앙의 징표",
	["FlashPowder"] = "섬광 화약",
	["SoulShard"] = "영혼의 조각",
	["Checks Disabled"] = "확인 사용안함",
	["Items"] = "아이템",
	["Reagents"] = "재료",
	["Close"] = "닫기",
	["Refresh"] = "갱신",
	["Name"] = "이름",
	["Item"] = "아이템",
	["Amount"] = "수량",
	["Nr"] = "갯수",
	["Perform item check"] = "아이템 확인 실시",
	["Check the raid for an item."] = "공격대원의 아이템을 확인합니다.",
	["<item>"] = "<아이템>",
	["Perform reagent check"] = "재료 확인 실시",
	["Check the raid for reagents."] = "공격대원의 재료를 확인합니다.",
	["Leader/Item"] = "공격대장/아이템",
} end )

L:RegisterTranslations("zhCN", function() return {
	["itemleader"] = "itemleader",
	["item"] = "物品",
	["Options for item checks."] = "物品检查选项",
	["SacredCandle"] = "神圣蜡烛",
	["ArcanePowder"] = "魔粉",
	["WildThornroot"] = "野生棘根草",
	["Ankh"] = "十字章",
	["SymbolofDivinity"] = "神圣符印",
	["FlashPowder"] = "闪光粉",
	["SoulShard"] = "灵魂碎片",
	["Checks Disabled"] = "禁止检查",
	["Items"] = "物品",
	["Reagents"] = "施法材料",
	["Close"] = "关闭",
	["Refresh"] = "刷新",
	["Name"] = "姓名",
	["Item"] = "物品",
	["Amount"] = "数量",
	["Nr"] = "数量",
	["Perform item check"] = "进行物品检查",
	["Check the raid for an item."] = "对团队进行物品检查",
	["<item>"] = "<物品>",
	["Perform reagent check"] = "进行施法材料检查",
	["Check the raid for reagents."] = "对团队进行施法材料检查",
	["check"] = "检查",
	["reagent"] = "施法材料",
	["Leader/Item"] = "Leader/Item",
} end )

L:RegisterTranslations("zhTW", function() return {
	["itemleader"] = "itemleader",
	["item"] = "物品",
	["Options for item checks."] = "物品檢查選項",
	["SacredCandle"] = "神聖蠟燭",
	["ArcanePowder"] = "魔粉",
	["WildThornroot"] = "野生棘根草",
	["Ankh"] = "十字章",
	["SymbolofDivinity"] = "神聖符印",
	["FlashPowder"] = "閃光粉",
	["SoulShard"] = "靈魂碎片",
	["Checks Disabled"] = "檢查已停用",
	["Items"] = "物品",
	["Reagents"] = "施法材料",
	["Close"] = "關閉",
	["Refresh"] = "更新",
	["Name"] = "姓名",
	["Item"] = "物品",
	["Amount"] = "數量",
	["Nr"] = "數量",
	["Perform item check"] = "進行物品檢查",
	["Check the raid for an item."] = "對團隊進行物品檢查",
	["<item>"] = "<物品>",
	["Perform reagent check"] = "進行施法材料檢查",
	["Check the raid for reagents."] = "對團隊進行施法材料檢查",
	["check"] = "檢查",
	["reagent"] = "施法材料",
	["Leader/Item"] = "Leader/Item",
} end )

L:RegisterTranslations("deDE", function() return {
	-- ["itemleader"] = "",
	-- ["item"] = "",
	["Options for item checks."] = "Optionen f\195\188r Gegenstands-Check",

	["SacredCandle"] = "Hochheilige Kerze",
	["ArcanePowder"] = "Arkanes Pulver",
	["WildThornroot"] = "Wilder Dornwurz",
	["Ankh"] = "Ankh",

	["SymbolofDivinity"] = "Symbol der K\195\182nige",
	-- ["SymbolofDivinity"] = "Symbol der Offenbarung",

	["FlashPowder"] = "Blitzstrahlpulver",
	["SoulShard"] = "Seelensplitter",

	["Checks Disabled"] = "Deaktiviere \195\156berpr\195\188fungen",
	["Items"] = "Gegenst\195\164nde",
	["Reagents"] = "Reagenzien",
	["Close"] = "Schlie\195\159en",
	["Refresh"] = "Erneuern",
	["Name"] = "Name",
	["Item"] = "Gegenstand",
	["Amount"] = "Anzahl",
	["Nr"] = "Nr",
	["Perform item check"] = "Starte eine Gegenstands-Check",
	["Check the raid for an item."] = "\195\156berpr\195\188ft die Schlachtgruppea auf einen Gegenstand.",
	["<item>"] = "<item>",
	["Perform reagent check"] = "Starte einen Reagenzien-Check",
	["Check the raid for reagents."] = "\195\156berpr\195\188ft die Schlachtgruppea auf Reagenzien.",
	-- ["check"] = "",
	-- ["reagent"] = "",
	["Leader/Item"] = "Anf\195\188hrer/Gegenstand",
} end )

L:RegisterTranslations("frFR", function() return {
	--["itemleader"] = true,
	--["item"] = true,
	["Options for item checks."] = "Options concernant les v\195\169rifications des objets.",
	["SacredCandle"] = "Bougie sacr\195\169e",
	["ArcanePowder"] = "Poudre des arcanes",
	["WildThornroot"] = "Ronceterre sauvage",
	["Ankh"] = "Ankh",
	["SymbolofDivinity"] = "Symbole de divinit\195\169",
	["FlashPowder"] = "Poudre aveuglante",
	["SoulShard"] = "Fragment d'\195\162me",
	["Checks Disabled"] = "V\195\169rifications d\195\169sactiv\195\169es.",
	["Items"] = "Objets",
	["Reagents"] = "Composants",
	["Close"] = "Fermer",
	["Refresh"] = "Rafra\195\174chir",
	["Name"] = "Nom",
	["Item"] = "Objet",
	["Amount"] = "Quantit\195\169",
	["Nr"] = "N\194\176",
	["Perform item check"] = "V\195\169rifier un objet",
	["Check the raid for an item."] = "V\195\169rifie la disponibilit\195\169 d'un objet dans le raid.",
	["<item>"] = "<objet>",
	["Perform reagent check"] = "V\195\169rifier les composants",
	["Check the raid for reagents."] = "V\195\169rifie les composants du raid.",
	--["check"] = true,
	--["reagent"] = true,
	["Leader/Item"] = "Chef/Objet",
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = oRA:NewModule(L["itemleader"])
mod.defaults = {}
mod.leader = true
mod.name = L["Leader/Item"]
mod.consoleCmd = L["item"]
mod.consoleOptions = {
	type = "group",
	desc = L["Options for item checks."],
	name = L["Item"],
	args = {
		[L["check"]] = {
			type="text", name = L["Perform item check"],
			desc = L["Check the raid for an item."],
			get = false,
			set = function(v)
					mod:PerformItemCheck(v)
				end,
			validate = function(v)
					return v:find("(.+)")
				end,
			usage = L["<item>"],
			disabled = function() return not oRA:IsModuleActive(mod) or not mod:IsValidRequest() end,
		},
		[L["reagent"]] = {
			type="execute", name = L["Perform reagent check"],
			desc = L["Check the raid for reagents."],
			func = function()
					mod:PerformReagentCheck()
				end,
			disabled = function() return not oRA:IsModuleActive(mod) or not mod:IsValidRequest() end,
		},
	}
}

------------------------------
--      Initialization      --
------------------------------

local header = nil
local entry = nil
local frame = nil
local items = {}
local sorting = {
	L["Name"],
	L["Item"],
	L["Amount"],
}

function mod:OnEnable()
	self:RegisterCheck("ITM", "oRA_ItemResponse")
	self:RegisterCheck("REA", "oRA_ReagentResponse")

	self:RegisterShorthand("raitem", function(item) self:PerformItemCheck(item) end )
	self:RegisterShorthand("rareg", function() self:PerformReagentCheck() end )
end

function mod:OnDisable()
	self:UnregisterCheck("ITM")
	self:UnregisterCheck("REA")

	self:UnregisterShorthand("raitem")
	self:UnregisterShorthand("rareg")
end

function mod:oRA_ItemResponse( msg, author)
	if not self:IsValidRequest(author, true) then return end
	local numitems,itemname,requestby = select(3, msg:find("^ITM ([-%d]+) (.+) ([^%s]+)$"))
	if numitems and itemname and requestby and requestby == UnitName("player") then
		numitems = tonumber(numitems)
		if numitems == -1 then
			self:AddPlayer( author, L["Checks Disabled"], 0 )
		else
			self:AddPlayer( author, itemname, numitems )
		end
		self:UpdateScrollBar()
	end
end

function mod:oRA_ReagentResponse( msg, author)
	--msg = self:CleanMessage(msg)
	local numitems,requestby = select(3, msg:find("^REA ([^%s]+) ([^%s]+)$"))
	if numitems and requestby and requestby == UnitName("player") then
		numitems = tonumber(numitems)
		for i = 1, GetNumRaidMembers(), 1 do
			local rostername = GetRaidRosterInfo(i)
			if rostername == author then
				if UnitClass("raid"..i) then
					local class = select(2, UnitClass("raid"..i))
					if reagents[class] then
						if numitems == -1 then
							self:AddPlayer( author, L["Checks Disabled"], 0 )
						else
							self:AddPlayer( author, L[reagents[class]], numitems )
						end
						self:UpdateScrollBar()
					end
				end
			end
		end
	end
end

---------------------------
--   Utility Functions   --
---------------------------

function mod:AddPlayer( nick, item, amount )
	local update
	for i = 1, 40, 1 do
		if items[i] and items[i][1] == nick then
			update = i
		end
	end
	if update then
		items[update][3] = amount or 0
	else
		table.insert(items,{nick, item, amount or 0})
	end
end

function mod:SetupFrames()
	if frame then return end

	local f = GameFontNormal:GetFont()

	local main = CreateFrame("Frame", "oRAItemReportFrame", UIParent)
	main:Hide()
	main:SetWidth(325)
	main:SetHeight(350)
	main:EnableMouse(true)
	main:SetMovable(true)
	main:RegisterForDrag("LeftButton")
	main:SetScript("OnDragStart", function() this:StartMoving() end)
	main:SetScript("OnDragStop", function() this:StopMovingOrSizing() end)
	main:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
	main:SetBackdropBorderColor(.5, .5, .5)
	main:SetBackdropColor(0,0,0)
	main:ClearAllPoints()
	main:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)

	-- File-wide pointer
	frame = main

	local fade = main:CreateTexture(nil, "BORDER")
	fade:SetWidth(319)
	fade:SetHeight(25)
	fade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	fade:SetPoint("TOP", main, "TOP", 0, -4)
	fade:SetBlendMode("ADD")
	fade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1)

	header = main:CreateFontString(nil,"OVERLAY")
	header:SetFont(f, 14)
	header:SetWidth(300)
	header:SetText("Durability")
	header:SetTextColor(1, .8, 0)
	header:ClearAllPoints()
	header:SetPoint("TOP", main, "TOP", 0, -10)

	local headername = CreateFrame("Button", nil, main)
	headername:SetWidth(125)
	headername:SetHeight(16)
	headername:SetPoint("TOPLEFT", main, "TOPLEFT", 10, -35)
	headername:SetScript("OnClick", function()
		self:Sort(items, 1)
		self:UpdateScrollBar()
	end)

	local headernamehigh = headername:CreateTexture(nil, "BORDER")
	headernamehigh:SetWidth(125)
	headernamehigh:SetHeight(16)
	headernamehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headernamehigh:SetAllPoints(headername)
	headernamehigh:SetBlendMode("ADD")
	headernamehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headername:SetHighlightTexture(headernamehigh)

	local headernametext = headername:CreateFontString(nil,"OVERLAY")
	headernametext:SetFont(f, 14)
	headernametext:SetWidth(125)
	headernametext:SetText(L["Name"])
	headernametext:SetTextColor(1, .8, 0)
	headernametext:ClearAllPoints()
	headernametext:SetJustifyH("LEFT")
	headernametext:SetAllPoints(headername)

	local headeritem = CreateFrame("Button", nil, main)
	headeritem:SetWidth(125)
	headeritem:SetHeight(16)
	headeritem:SetPoint("LEFT", headername, "RIGHT")
	headeritem:SetScript("OnClick", function()
		self:Sort(items, 2)
		self:UpdateScrollBar()
	end)

	local headeritemhigh = headeritem:CreateTexture(nil, "BORDER")
	headeritemhigh:SetWidth(125)
	headeritemhigh:SetHeight(16)
	headeritemhigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headeritemhigh:SetAllPoints(headeritem)
	headeritemhigh:SetBlendMode("ADD")
	headeritemhigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headeritem:SetHighlightTexture(headeritemhigh)

	local headeritemtext = main:CreateFontString(nil,"OVERLAY")
	headeritemtext:SetFont(f, 14)
	headeritemtext:SetWidth(125)
	headeritemtext:SetText(L["Item"])
	headeritemtext:SetTextColor(1, .8, 0)
	headeritemtext:ClearAllPoints()
	headeritemtext:SetJustifyH("LEFT")
	headeritemtext:SetAllPoints(headeritem)

	local headeramount = CreateFrame("Button", nil, main)
	headeramount:SetWidth(30)
	headeramount:SetHeight(16)
	headeramount:SetPoint("LEFT", headeritem, "RIGHT")
	headeramount:SetScript("OnClick", function()
		self:Sort(items, 3)
		self:UpdateScrollBar()
	end)

	local headeramounthigh = headeramount:CreateTexture(nil, "BORDER")
	headeramounthigh:SetWidth(30)
	headeramounthigh:SetHeight(16)
	headeramounthigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headeramounthigh:SetAllPoints(headeramount)
	headeramounthigh:SetBlendMode("ADD")
	headeramounthigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headeramount:SetHighlightTexture(headeramounthigh)

	local headeramounttext = main:CreateFontString(nil,"OVERLAY")
	headeramounttext:SetFont(f, 14)
	headeramounttext:SetWidth(30)
	headeramounttext:SetText(L["Nr"])
	headeramounttext:SetTextColor(1, .8, 0)
	headeramounttext:ClearAllPoints()
	headeramounttext:SetJustifyH("LEFT")
	headeramounttext:SetAllPoints(headeramount)

	local leftbutton = CreateFrame("Button", nil, main)
	leftbutton:SetWidth(125)
	leftbutton:SetHeight(32)
	leftbutton:SetPoint("BOTTOMRIGHT", main, "BOTTOM", -10, 10)

	local t = leftbutton:CreateTexture()
	t:SetWidth(125)
	t:SetHeight(32)
	t:SetPoint("CENTER", leftbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	leftbutton:SetNormalTexture(t)

	t = leftbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(leftbutton)
	leftbutton:SetPushedTexture(t)

	t = leftbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(leftbutton)
	t:SetBlendMode("ADD")
	leftbutton:SetHighlightTexture(t)

	local leftbuttontext = leftbutton:CreateFontString(nil,"OVERLAY")
	leftbuttontext:SetFontObject(GameFontHighlight)
	leftbuttontext:SetText(L["Refresh"])
	leftbuttontext:SetAllPoints(leftbutton)

	leftbutton:SetScript("OnClick", function()
		self:PerformItemCheck()
	end)

	local rightbutton = CreateFrame("Button", nil, main)
	rightbutton:SetWidth(125)
	rightbutton:SetHeight(32)
	rightbutton:SetPoint("BOTTOMLEFT", main, "BOTTOM", 10, 10)

	t = rightbutton:CreateTexture()
	t:SetWidth(125)
	t:SetHeight(32)
	t:SetPoint("CENTER", rightbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	rightbutton:SetNormalTexture(t)

	t = rightbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(rightbutton)
	rightbutton:SetPushedTexture(t)

	t = rightbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(rightbutton)
	t:SetBlendMode("ADD")
	rightbutton:SetHighlightTexture(t)

	local rightbuttontext = rightbutton:CreateFontString(nil,"OVERLAY")
	rightbuttontext:SetFontObject(GameFontHighlight)
	rightbuttontext:SetText(L["Close"])
	rightbuttontext:SetAllPoints(rightbutton)

	rightbutton:SetScript("OnClick", function()
		main:Hide()
	end)


	entry = {}
	entry[1] = self:ScrollEntryFrame()
	entry[1]:SetPoint("TOPLEFT", main, "TOPLEFT", 10, -55 )
	for i=2, 15 do
		j = i - 1
		entry[i] = self:ScrollEntryFrame()
		entry[i]:SetPoint("TOPLEFT", entry[j], "BOTTOMLEFT")
	end

	local sframe = CreateFrame("ScrollFrame", "oRAItemScrollFrame", main, "FauxScrollFrameTemplate")
	sframe:SetWidth(285)
	sframe:SetHeight(240)
	sframe:SetPoint("TOPLEFT", main, "TOPLEFT", 5, -55)

	local function scrollUpdate()
		self:UpdateScrollBar()
	end

	sframe:SetScript("OnVerticalScroll", function()
		FauxScrollFrame_OnVerticalScroll(16, scrollUpdate)
	end)
end

function mod:ScrollEntryFrame()
	local f = CreateFrame("Button", nil, frame)
	f:SetWidth(240)
	f:SetHeight(16)

	local textname = f:CreateFontString(nil,"ARTWORK")
	textname:SetFontObject(GameFontHighlight)
	textname:SetWidth(125)
	textname:SetHeight(16)
	textname:SetJustifyH("LEFT")
	textname:SetNonSpaceWrap(false)
	textname:ClearAllPoints()
	textname:SetPoint( "LEFT", f, "LEFT")
	textname:SetTextColor(1,1,1)
	textname:SetText(L["Name"])

	local textitem = f:CreateFontString(nil,"ARTWORK")
	textitem:SetFontObject(GameFontHighlight)
	textitem:SetWidth(125)
	textitem:SetHeight(16)
	textitem:SetJustifyH("LEFT")
	textitem:SetNonSpaceWrap(false)
	textitem:ClearAllPoints()
	textitem:SetPoint("LEFT", textname, "RIGHT")
	textitem:SetTextColor(1,1,1)
	textitem:SetText("125")

	local textamount = f:CreateFontString(nil,"ARTWORK")
	textamount:SetFontObject(GameFontHighlight)
	textamount:SetWidth(30)
	textamount:SetHeight(16)
	textamount:SetJustifyH("RIGHT")
	textamount:SetNonSpaceWrap(false)
	textamount:ClearAllPoints()
	textamount:SetPoint("LEFT", textitem, "RIGHT")
	textamount:SetTextColor(1,1,1)
	textamount:SetText("3")

	return f
end

local paintchips = nil
local RL = nil
function mod:UpdateScrollBar()
	self:SetupFrames()
	local entries = #items
	FauxScrollFrame_Update(sframe, entries, 15, 16)

	if not paintchips then paintchips = AceLibrary("PaintChips-2.0") end
	if not RL then RL = AceLibrary("Roster-2.1") end

	for i = 1, 15 do
		local j = i + FauxScrollFrame_GetOffset(sframe)

		if j <= entries then
			local class = RL:GetUnitObjectFromName(items[j][1]).class
			entry[i].textname:SetText("|cff"..paintchips:GetHex(class)..items[j][1].."|r")
			entry[i].textitem:SetText(items[j][2])
			entry[i].textamount:SetText(items[j][3])
			entry[i]:Show()
		else
			entry[i]:Hide()
		end
	end
end

--------------------------
--   Command Handlers   --
--------------------------

function mod:PerformItemCheck( item )
	if not self:IsPromoted() then return end
	local linkName = select(3, item:find("%[(.+)%]"))
	if ( linkName ) then
		item = linkName
	end
	self.item = item

	items = nil
	items = {}

	self:SendMessage( "ITMC "..item )

	self:SetupFrames()
	header:SetText(L["Items"])
	leftbutton:SetScript("OnClick", function()
		self:PerformItemCheck( self.item )
	end)
	local i
	for i=1, 40 do
		if UnitExists("raid" .. i) then
			self:AddPlayer(UnitName("raid" .. i), item)
		end
	end

	frame:Show()
	self:UpdateScrollBar()
end

function mod:PerformReagentCheck()
	if not self:IsPromoted() then return end

	items = nil
	items = {}

	self:SendMessage( "REAC" )

	self:SetupFrames()

	header:SetText(L["Reagents"])
	leftbutton:SetScript("OnClick", function()
		self:PerformReagentCheck()
	end)

	frame:Show()
	self:UpdateScrollBar()
end


function mod:Sort( tbl, sortBy )
	table.sort(tbl,
		function(t1, t2)
			if (t1[sortBy] == t2[sortBy] ) then
				return t1[1] < t2[1]
			else
				return t1[sortBy] > t2[sortBy]
			end
		end
	)
end

