﻿
assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRALReady")

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["ready"] = true,
	["readyleader"] = true,
	["Options for ready checks and votes."] = true,
	["sound"] = true,
	["Sound"] = true,
	["Toggle an audio warning upon a ready check or vote."] = true,
	["Ready"] = true,
	["Not Ready"] = true,
	["Are you Ready?"] = true,
	["Yes"] = true,
	["No"] = true,
	["Ready Check"] = true,
	["check"] = true,
	["Perform a ready check."] = true,
	["Close"] = true,
	["<CTRaid> %s has performed a ready check."] = true,
	["AFK: "] = true,
	["Not Ready: "] = true,
	["Yes: %d No: %d AFK: %d"] = true,
	["Vote Results for: "] = true,
	["<CTRaid> %s has performed a vote: %s"] = true,
	["Vote"] = true,
	["vote"] = true,
	["Perform a vote."] = true,
	["<vote>"] = true,
	["Leader/Ready"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Options for ready checks and votes."] = "준비확인과 투표 설정",
	["Sound"] = "소리",
	["Toggle an audio warning upon a ready check or vote."] = "준비확인시와 투표시에 경고음 재생 기능을 토글합니다.",
	["Ready"] = "준비완료",
	["Not Ready"] = "준비안됨",
	["Are you Ready?"] = "준비 되셨습니까?",
	["Yes"] = "예",
	["No"] = "아니오",
	["Ready Check"] = "준비 확인",
	["Perform a ready check."] = "준비 상태를 확인 합니다.",
	["Close"] = "닫기",
	["<CTRaid> %s has performed a ready check."] = "<공격대 도우미> %s님이 준비 상태를 확인합니다.",
	["AFK: "] = "자리비움: ",
	["Not Ready: "] = "준비안됨: ",
	["Yes: %d No: %d AFK: %d"] = "예: %d 아니오: %d 자리비움: %d",
	["Vote Results for: "] = "투표 결과: ",
	["<CTRaid> %s has performed a vote: %s"] = "<공격대 도우미> %s님이 투표를 실시합니다.: %s",
	["Vote"] = "투표",
	["Perform a vote."] = "투표를 실시합니다.",
	["<vote>"] = "투표",
	["Leader/Ready"] = "공격대장/준비확인",
} end)

L:RegisterTranslations("zhCN", function() return {
	["ready"] = "就位确认",
	["readyleader"] = "就位确认与投票助手",
	["Options for ready checks and votes."] = "就位确认与投票设置",
	["sound"] = "声音",
	["Sound"] = "声音",
	["Toggle an audio warning upon a ready check or vote."] = "就位确认与投票时播放音效",
	["Ready"] = "就位确认",
	["Not Ready"] = "未准备好",
	["Are you Ready?"] = "准备好了么？",
	["Yes"] = "是",
	["No"] = "否",
	["Ready Check"] = "就位确认",
	["check"] = "检查",
	["Perform a ready check."] = "进行检查",
	["Close"] = "关闭",
	["<CTRaid> %s has performed a ready check."] = "<CTRaid>%s正在进行就位检查",
	["AFK: "] = "暂离: ",
	["Not Ready: "] = "未就绪",
	["Yes: %d No: %d AFK: %d"] = "是：%d 否：%d 暂离：%d",
	["Vote Results for: "] = "投票结果：",
	["<CTRaid> %s has performed a vote: %s"] = "<CTRaid>%s开始一场投票：%s",
	["Vote"] = "投票",
	["vote"] = "投票",
	["Perform a vote."] = "进行投票",
	["<vote>"] = "<vote>",
	["Leader/Ready"] = "Leader/Ready",
} end)

L:RegisterTranslations("zhTW", function() return {
	["ready"] = "就位確認",
	["readyleader"] = "readyleader",
	["Options for ready checks and votes."] = "就位確認與投票選項",
	["sound"] = "聲音",
	["Sound"] = "聲音",
	["Toggle an audio warning upon a ready check or vote."] = "就位確認與投票時播放音效",
	["Ready"] = "已就緒",
	["Not Ready"] = "未就緒",
	["Are you Ready?"] = "準備好了嗎？",
	["Yes"] = "是",
	["No"] = "否",
	["Ready Check"] = "就位確認",
	["check"] = "檢查",
	["Perform a ready check."] = "進行就位確認",
	["Close"] = "關閉",
	["<CTRaid> %s has performed a ready check."] = "<CTRaid>%s正在進行就位確認",
	["AFK: "] = "暫離: ",
	["Not Ready: "] = "未就緒",
	["Yes: %d No: %d AFK: %d"] = "是：%d 否：%d 暫離：%d",
	["Vote Results for: "] = "投票結果：",
	["<CTRaid> %s has performed a vote: %s"] = "<CTRaid>%s開始一場投票：%s",
	["Vote"] = "投票",
	["vote"] = "投票",
	["Perform a vote."] = "進行投票",
	["<vote>"] = "<投票>",
	["Leader/Ready"] = "領隊/就位確認",
} end)

L:RegisterTranslations("frFR", function() return {
	--["ready"] = true,
	--["readyleader"] = true,
	["Options for ready checks and votes."] = "Options concernant les appels et les votes.",
	--["sound"] = true,
	["Sound"] = "Son",
	["Toggle an audio warning upon a ready check or vote."] = "Joue ou non un avertissement sonore lors d'un appel ou d'un vote.",
	["Ready"] = "Pr\195\170t",
	["Not Ready"] = "Pas pr\195\170t",
	["Are you Ready?"] = "\195\138tes-vous pr\195\170t ?",
	["Yes"] = "Oui",
	["No"] = "Non",
	["Ready Check"] = "Appel",
	--["check"] = true,
	["Perform a ready check."] = "Effectue l'appel.",
	["Close"] = "Fermer",
	["<CTRaid> %s has performed a ready check."] = "<CTRaid> %s a commenc\195\169 l'appel.",
	["AFK: "] = "ABS : ",
	["Not Ready: "] = "Pas pr\195\170t : ",
	["Yes: %d No: %d AFK: %d"] = "Oui : %d Non : %d ABS : %d",
	["Vote Results for: "] = "R\195\169sultat du vote pour : ",
	["<CTRaid> %s has performed a vote: %s"] = "<CTRaid> %s a lanc\195\169 un vote: %s",
	--["Vote"] = true,
	--["vote"] = true,
	["Perform a vote."] = "Soumet un vote au raid.",
	--["<vote>"] = true,
	["Leader/Ready"] = "Chef/Appel",
} end)

L:RegisterTranslations("deDE", function() return {
	-- ["ready"] = "",
	-- ["readyleader"] = "",
	["Options for ready checks and votes."] = "Optionen f\195\188r Bereichtschaftschecks und Abstimmungen.",
	-- ["sound"] = "",
	["Sound"] = "Sound",
	["Toggle an audio warning upon a ready check or vote."] = "Bei einem Bereitschaftscheck oder einer Abstimmung einen Warnton ausgeben.",
	["Ready"] = "Bereitschaft",
	["Not Ready"] = "Nicht Bereit",
	["Are you Ready?"] = "Bist du Bereit?",
	["Yes"] = "Ja",
	["No"] = "Nein",
	["Ready Check"] = "Bereitschaftscheck",
	-- ["check"] = "check",
	["Perform a ready check."] = "Startet einen Bereitschaftscheck.",
	["Close"] = "Schlie\195\159en",
	["<CTRaid> %s has performed a ready check."] = "<oRA2> %s hat einen Bereitschaftcheck gestartet.",
	["AFK: "] = "AFK: ",
	["Not Ready: "] = "Nicht Bereit: ",
	["Yes: %d No: %d AFK: %d"] = "Ja: %d Nein: %d AFK: %d",
	["Vote Results for: "] = "Abstimmungsergebnis f\195\188r: ",
	["<CTRaid> %s has performed a vote: %s"] = "<oRA2> %s hat eine Abstimmung gestartet.",
	["Vote"] = "Abstimmung",
	["vote"] = "abstimmen",
	["Perform a vote."] = "Starte eine Abstimmung.",
	["<vote>"] = "<abstimmen>",
	["Leader/Ready"] = "Anf\195\188hrer/Bereitschaft",
} end)

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = oRA:NewModule(L["readyleader"])
mod.defaults = {
	sound = true,
}
mod.leader = true
mod.name = L["Leader/Ready"]
mod.consoleCmd = L["ready"]
mod.consoleOptions = {
	type = "group",
	desc = L["Options for ready checks and votes."],
	name = L["Ready"],
	disabled = function() return not oRA:IsActive() end,
	args = {
		[L["check"]] = {
			name = L["Ready Check"], type = "execute",
			desc = L["Perform a ready check."],
			func = function()
				mod:PerformReadyCheck()
			end,
			disabled = function() return not oRA:IsModuleActive(mod) or not mod:IsValidRequest() end,
		},
		[L["vote"]] = {
			name = L["Vote"], type = "text",
			desc = L["Perform a vote."],
			usage = L["<vote>"],
			get = false,
			set = function(v)
				mod:PerformVote(v)
			end,
			validate = function(v)
				return v:find("^(.+)$")
			end,
			disabled = function() return not oRA:IsModuleActive(mod) or not mod:IsValidRequest() end,
		}
	}
}

------------------------------
--      Initialization      --
------------------------------

local votes = {}
local ready = {}

function mod:OnEnable()
	self:RegisterCheck("READY", "oRA_Ready")
	self:RegisterCheck("NOTREADY", "oRA_NotReady")
	self:RegisterCheck("VOTEYES", "oRA_VoteYes")
	self:RegisterCheck("VOTENO", "oRA_VoteNo")

	self:RegisterShorthand("raready", function() self:PerformReadyCheck() end )
	self:RegisterShorthand("rar", function() self:PerformReadyCheck() end )
	self:RegisterShorthand("ravote", function(vote) self:PerformVote(vote) end )

	self:SetupFrames()
end

function mod:OnDisable()
	self:UnregisterCheck("READY")
	self:UnregisterCheck("NOTREADY")
	self:UnregisterCheck("VOTEYES")
	self:UnregisterCheck("VOTENO")

	self:UnregisterShorthand("raready")
	self:UnregisterShorthand("rar")
	self:UnregisterShorthand("ravote")

	for k in pairs(votes) do votes[k] = nil end
	for k in pairs(ready) do ready[k] = nil end
end

-------------------------
--   Command Handlers  --
-------------------------

local closebuttontext = nil
local closebutton = nil
local frame = nil
local question = nil

function mod:PerformReadyCheck()
	if not self:IsPromoted() then return end
	for k in pairs(ready) do ready[k] = nil end

	for i = 1, GetNumRaidMembers(), 1 do
		local name, _, _, _, _, _, _, online = GetRaidRosterInfo(i)
		if online then ready[name] = "no reply" end
	end
	
	ready[UnitName("player")] = "ready"

	rheader:SetText(L["Ready Check"])
	leftinfo:SetText("")
	rightinfo:SetText("")

	closebuttontext:SetText(L["Close"])

	closebutton:SetScript("OnClick",
		function()
			this.owner:ReportReadyStatus()
			this.owner.frames.report:Hide()
		end )

	report:Show()
	self:UpdateReport(ready, "ready", "not ready")

	SendChatMessage(string.format( L["<CTRaid> %s has performed a ready check."], name), "RAID")
	self:SendMessage("CHECKREADY")
end

function mod:PerformVote( question )
	if not self:IsPromoted() then return end
	if not question or question == "" then return end

	question = question
	for k in pairs(votes) do votes[k] = nil end

	for i = 1, GetNumRaidMembers(), 1 do
		local name, _, _, _, _, _, _, online = GetRaidRosterInfo(i)
		if online and name ~= UnitName("player") then self.votes[name] = "no reply" end
	end

	rheader:SetText(L["Vote"])
	leftinfo:SetText("")
	rightinfo:SetText("")

	closebuttontext:SetText(L["Close"])

	closebutton:SetScript("OnClick", function()
		self:ReportVoteStatus()
		frame:Hide()
	end )

	frame:Show()
	self:UpdateReport(votes, "yes", "no")
	SendChatMessage(string.format( L["<CTRaid> %s has performed a vote: %s"], UnitName("player"), question), "RAID")
	self:SendMessage("VOTE "..question)
end

-------------------------
--   Event Handlers    --
-------------------------

function mod:oRA_Ready(msg, author)
	if not self:IsPromoted() then return end
	ready[author] = "ready"
	self:UpdateReport(self.ready, "ready", "not ready")
end

function mod:oRA_NotReady(msg, author)
	if not self:IsPromoted() then return end
	ready[author] = "not ready"
	self:UpdateReport(self.ready, "ready", "not ready")
end

function mod:oRA_VoteYes(msg, author)
	if not self:IsPromoted() then return end
	votes[author] = "yes"
	self:UpdateReport(self.votes, "yes", "no")	
end

function mod:oRA_VoteNo(msg, author)
	if not self:IsPromoted() then return end
	votes[author] = "no"
	self:UpdateReport(self.votes, "yes", "no")
end

--------------------------
--     Core function    --
--------------------------

function mod:ReportReadyStatus()
	local noreply, notready = "", ""
	for name, ready in pairs(ready) do
		if ready == "no reply" then noreply = noreply..name.." "
		elseif ready == "not ready" then notready = notready..name.." "
		end
	end
	if noreply ~= "" then self:Print(L["AFK: "]..noreply) end
	if notready ~= "" then self:Print(L["Not Ready: "]..notready) end
end

function mod:ReportVoteStatus()
	local noreply, yes, no = 0,0,0
	for name, vote in pairs(votes) do
		if vote == "no reply" then noreply = noreply + 1
		elseif vote == "no" then no = no + 1
		else yes = yes + 1
		end
	end
	SendChatMessage( L["Vote Results for: "]..question, "RAID")
	SendChatMessage( string.format(L["Yes: %d No: %d AFK: %d"], yes, no, noreply), "RAID")
end


------------------------------------
--     Frame Setup and Handling   --
------------------------------------

function mod:UpdateReport(t, green, red)
	local text = ""
	local i = 0
	for name, state in pairs(t) do
		i = i + 1
		if i == 21 then text = "" end
		
		if state == "no reply" then
			text = text .. "|c00CCCCCC" .. name .. "|r\n"
		elseif state == red then
			text = text .. "|c00FF0000" .. name .. "|r\n"
		else
			text = text .. "|c0000FF00" .. name .. "|r\n"
		end
		
		if i <= 20 then leftinfo:SetText(text)
		else rightinfo:SetText(text) end
	end
end


function mod:SetupFrames()
	local f = GameFontNormal:GetFont()
	local report = CreateFrame("Frame", nil, UIParent)
	report:Hide()
	report:SetWidth(325)
	report:SetHeight(325)
	report:EnableMouse(true)
	report:SetMovable(true)
	report:RegisterForDrag("LeftButton")
	report:SetScript("OnDragStart", function() this:StartMoving() end)
	report:SetScript("OnDragStop", function() this:StopMovingOrSizing() end)
	report:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
	report:SetBackdropBorderColor(.5, .5, .5)
	report:SetBackdropColor(0,0,0)
	report:ClearAllPoints()
	report:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)

	-- Local pointer
	frame = report

	local rfade = report:CreateTexture(nil, "BORDER")
	rfade:SetWidth(319)
	rfade:SetHeight(25)
	rfade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	rfade:SetPoint("TOP", report, "TOP", 0, -4)
	rfade:SetBlendMode("ADD")
	rfade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1)

	local rheader = report:CreateFontString(nil,"OVERLAY")
	rheader:SetFont(f, 14)
	rheader:SetWidth(300)
	rheader:SetText("header")
	rheader:SetTextColor(1, .8, 0)
	rheader:ClearAllPoints()
	rheader:SetPoint("TOP", report, "TOP", 0, -10)
	
	local leftinfo = report:CreateFontString(nil,"OVERLAY")
	leftinfo:SetFont(f, 12)
	leftinfo:SetWidth(175)
	leftinfo:SetHeight(300)
	leftinfo:SetJustifyV("TOP")
	leftinfo:SetText("leftinfo")
	leftinfo:ClearAllPoints()
	leftinfo:SetPoint("TOPLEFT", report, "TOPLEFT", 0, -30)

	local rightinfo = report:CreateFontString(nil,"OVERLAY")
	rightinfo:SetFont(f, 12)
	rightinfo:SetWidth(175)
	rightinfo:SetHeight(300)
	rightinfo:SetJustifyV("TOP")
	rightinfo:SetText("rightinfo")
	rightinfo:ClearAllPoints()
	rightinfo:SetPoint("TOPRIGHT", report, "TOPRIGHT", 0, -30)

	closebutton = CreateFrame("Button", nil, report)
	closebutton.owner = self
	closebutton:SetWidth(125)
	closebutton:SetHeight(32)
	closebutton:SetPoint("BOTTOM", report, "BOTTOM", 0, 10)

	local t = closebutton:CreateTexture()
	t:SetWidth(125)
	t:SetHeight(32)
	t:SetPoint("CENTER", closebutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	closebutton:SetNormalTexture(t)

	t = closebutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(closebutton)
	closebutton:SetPushedTexture(t)

	t = closebutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(closebutton)
	t:SetBlendMode("ADD")
	closebutton:SetHighlightTexture(t)

	closebuttontext = closebutton:CreateFontString(nil,"OVERLAY")
	closebuttontext:SetFontObject(GameFontHighlight)
	closebuttontext:SetText("left")
	closebuttontext:SetAllPoints(closebutton)
end

