﻿
assert( oRA, "oRA not found!")

------------------------------
--      Are you local?      --
------------------------------

local L = AceLibrary("AceLocale-2.2"):new("oRALResist")

----------------------------
--      Localization      --
----------------------------

L:RegisterTranslations("enUS", function() return {
	["resist"] = true,
	["resistleader"] = true,
	["Options for resistance checks."] = true,
	["Leader/Resist"] = true,
	["Name"] = true,
	["Fire"] = true,
	["Nature"] = true,
	["Frost"] = true,
	["Shadow"] = true,
	["Arcane"] = true,
	["Resistance checks disabled."] = true,
	["Resistances"] = true,
	["Fr"] = true,
	["Ft"] = true,
	["N"] = true,
	["A"] = true,
	["S"] = true,
	["Refresh"] = true,
	["Close"] = true,
	["check"] = true,
	["Perform resistance check"] = true,
	["Check the raid's resistances."] = true,
} end )

L:RegisterTranslations("koKR", function() return {
	["Options for resistance checks."] = "공격대원 저항 확인 설정",
	["Leader/Resist"] = "공격대장/저항",
	["Name"] = "이름",
	["Fire"] = "화염",
	["Nature"] = "자연",
	["Frost"] = "냉기",
	["Shadow"] = "암흑",
	["Arcane"] = "비전",
	["Resistance checks disabled."] = "저항확인이 불가능합니다",
	["Resistances"] = "저항",
	["Fr"] = "화",
	["Ft"] = "냉",
	["N"] = "자",
	["A"] = "비",
	["S"] = "암",
	["Refresh"] = "갱신",
	["Close"] = "닫기",
	["Perform resistance check"] = "저항 확인 실시",
	["Check the raid's resistances."] = "공격대원의 저항을 확인합니다.",
} end )

L:RegisterTranslations("zhCN", function() return {
	["resist"] = "抗性",
	["resistleader"] = "resistleader",
	["Options for resistance checks."] = "抗性助手选项",
	["Leader/Resist"] = "Leader/Resist",
	["Name"] = "姓名",
	["Fire"] = "火焰",
	["Nature"] = "自然",
	["Frost"] = "冰霜",
	["Shadow"] = "暗影",
	["Arcane"] = "奥术",
	["Resistance checks disabled."] = "禁止抗性检查",
	["Resistances"] = "抗性",
	["Fr"] = "火",
	["Ft"] = "冰",
	["N"] = "自",
	["A"] = "奥",
	["S"] = "暗",
	["Refresh"] = "刷新",
	["Close"] = "关闭",
	["check"] = "检查",
	["Perform resistance check"] = "进行抗性检查",
	["Check the raid's resistances."] = "检查团队抗性",
} end )

L:RegisterTranslations("zhTW", function() return {
	["resist"] = "抗性",
	["resistleader"] = "resistleader",
	["Options for resistance checks."] = "抗性助手選項",
	["Leader/Resist"] = "領隊/抗性",
	["Name"] = "姓名",
	["Fire"] = "火焰",
	["Nature"] = "自然",
	["Frost"] = "冰霜",
	["Shadow"] = "陰影",
	["Arcane"] = "祕法",
	["Resistance checks disabled."] = "已停用抗性檢查",
	["Resistances"] = "抗性",
	["Fr"] = "火",
	["Ft"] = "冰",
	["N"] = "自",
	["A"] = "祕",
	["S"] = "陰",
	["Refresh"] = "更新",
	["Close"] = "關閉",
	["check"] = "檢查",
	["Perform resistance check"] = "進行抗性檢查",
	["Check the raid's resistances."] = "檢查團隊抗性",
} end )

L:RegisterTranslations("frFR", function() return {
	--["resist"] = true,
	--["resistleader"] = true,
	["Options for resistance checks."] = "Options concernant les v\195\169rifications des r\195\169sistances.",
	["Leader/Resist"] = "Chef/R\195\169sistances",
	["Name"] = "Nom",
	["Fire"] = "Feu",
	--["Nature"] = true,
	["Frost"] = "Givre",
	["Shadow"] = "Ombre",
	["Arcane"] = "Arcanes",
	["Resistance checks disabled."] = "V\195\169rifications des r\195\169sistances désactiv\195\169es.",
	["Resistances"] = "R\195\169sistances",
	["Fr"] = "F",
	["Ft"] = "G",
	--["N"] = true,
	--["A"] = true,
	["S"] = "O",
	["Refresh"] = "Rafra\195\174chir",
	["Close"] = "Fermer",
	--["check"] = true,
	["Perform resistance check"] = "V\195\169rifier les r\195\169sistances",
	["Check the raid's resistances."] = "V\195\169rifie les r\195\169sistances du raid.",
} end )

L:RegisterTranslations("deDE", function() return {
	-- ["resist"] = "",
	-- ["resistleader"] = "",
	["Options for resistance checks."] = "Optionen f\195\188r Resistenz-Checks.",
	["Leader/Resist"] = "Anf\195\188hrer/Restistenzen",
	["Name"] = "Name",
	["Fire"] = "Feuer",
	["Nature"] = "Natur",
	["Frost"] = "Frost",
	["Shadow"] = "Schatten",
	["Arcane"] = "Arkan",
	["Resistance checks disabled."] = "Resistenzen-Check deaktiviert",
	["Resistances"] = "Resistenzen",
	["Fr"] = "Fr",
	["Ft"] = "Ft",
	["N"] = "Nt",
	["A"] = "Ar",
	["S"] = "Sch",
	["Refresh"] = "Erneuern",
	["Close"] = "Schlie\195\159en",
	-- ["check"] = "",
	["Perform resistance check"] = "Starte einen Resistenzen-Check",
	["Check the raid's resistances."] = "\195\156berpr\195\188fe die Resistenz-Werte des Schlachtzuges.",
} end )

----------------------------------
--      Module Declaration      --
----------------------------------

local mod = oRA:NewModule(L["resistleader"])
mod.defaults = {}
mod.participant = true
mod.name = L["Leader/Resist"]
mod.consoleCmd = L["resist"]
mod.consoleOptions = {
	type = "group",
	desc = L["Options for resistance checks."],
	name = L["Resistances"],
	disabled = function() return not oRA:IsActive() end,	
	args = {
		[L["check"]] = {
			type="execute", name = L["Perform resistance check"],
			desc = L["Check the raid's resistances."],
			func = function()
					mod:PerformResistanceCheck()
				end,
			disabled = function() return not oRA:IsModuleActive(mod) or not mod:IsValidRequest() end,
		},

	}
}

------------------------------
--      Initialization      --
------------------------------

local entry = nil
local resists = {}
local sorting = {
	L["Name"],
	L["Fire"],
	L["Nature"],
	L["Frost"],
	L["Shadow"],
	L["Arcane"],
}
local frame = nil

function mod:OnEnable()
	self:RegisterCheck("RST", "oRA_ResistanceResponse")
	self:RegisterShorthand("raresist", function() self:PerformResistanceCheck() end )
end

function mod:OnDisable()
	self:UnregisterCheck("RST")
	self:UnregisterShorthand("raresist")
end

-------------------------
--   Event Handlers    --
-------------------------

function mod:oRA_ResistanceResponse( msg, author)
	local requestby = select(3, msg:find("^RST %-1 ([^%s]+)$"))
	if requestby and requestby == UnitName("player") then
		self:Print( author .. " " .. L["Resistance checks disabled."])
	else
		local fire, nature, frost, shadow, arcane, requestby = select(3, msg:find("^RST (%d+) (%d+) (%d+) (%d+) (%d+) ([^%s]+)$"))
		if fire and requestby and requestby == UnitName("player") then
			self:AddPlayer( author, tonumber(fire), tonumber(nature), tonumber(frost), tonumber(shadow), tonumber(arcane) )
			self:UpdateScrollBar()
		end
	end
end

-------------------------
--  Utility Functions  --
-------------------------

function mod:SetupFrames()
	if frame then return end

	local f = GameFontNormal:GetFont()

	local main = CreateFrame("Frame", "oRAResistReportFrame", UIParent)
	main:Hide()
	main:SetWidth(325)
	main:SetHeight(350)
	main:EnableMouse(true)
	main:SetMovable(true)
	main:RegisterForDrag("LeftButton")
	main:SetScript("OnDragStart", function() this:StartMoving() end)
	main:SetScript("OnDragStop", function() this:StopMovingOrSizing() end)
	main:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
		})
	main:SetBackdropBorderColor(.5, .5, .5)
	main:SetBackdropColor(0,0,0)
	main:ClearAllPoints()
	main:SetPoint("CENTER", WorldFrame, "CENTER", 0, 0)

	-- File-wide reference
	frame = main

	local fade = main:CreateTexture(nil, "BORDER")
	fade:SetWidth(319)
	fade:SetHeight(25)
	fade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	fade:SetPoint("TOP", main, "TOP", 0, -4)
	fade:SetBlendMode("ADD")
	fade:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1)

	local header = main:CreateFontString(nil,"OVERLAY")
	header:SetFont(f, 14)
	header:SetWidth(300)
	header:SetText(L["Resistances"])
	header:SetTextColor(1, .8, 0)
	header:ClearAllPoints()
	header:SetPoint("TOP", main, "TOP", 0, -10)

	local headername = CreateFrame("Button", nil, main)
	headername:SetWidth(130)
	headername:SetHeight(16)
	headername:SetPoint("TOPLEFT", main, "TOPLEFT", 10, -35)
	headername:SetScript("OnClick", function()
		self:Sort(resists, 1)
		self:UpdateScrollBar()
	end)

	local headernamehigh = headername:CreateTexture(nil, "BORDER")
	headernamehigh:SetWidth(130)
	headernamehigh:SetHeight(16)
	headernamehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headernamehigh:SetAllPoints(headername)
	headernamehigh:SetBlendMode("ADD")
	headernamehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headername:SetHighlightTexture(headernamehigh)

	local headernametext = headername:CreateFontString(nil,"OVERLAY")
	headernametext:SetFont(f, 14)
	headernametext:SetWidth(130)
	headernametext:SetText(L["Name"])
	headernametext:SetTextColor(1, .8, 0)
	headernametext:ClearAllPoints()
	headernametext:SetJustifyH("LEFT")
	headernametext:SetAllPoints(headername)

	local headerfire = CreateFrame("Button", nil, main)
	headerfire:SetWidth(30)
	headerfire:SetHeight(16)
	headerfire:SetPoint("LEFT", headername, "RIGHT")
	headerfire:SetScript("OnClick", function()
		self:Sort(resists, 2)
		self:UpdateScrollBar()
	end)

	local headerfirehigh = headerfire:CreateTexture(nil, "BORDER")
	headerfirehigh:SetWidth(30)
	headerfirehigh:SetHeight(16)
	headerfirehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headerfirehigh:SetAllPoints(headerfire)
	headerfirehigh:SetBlendMode("ADD")
	headerfirehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headerfire:SetHighlightTexture(headerfirehigh)

	local headerfiretext = main:CreateFontString(nil,"OVERLAY")
	headerfiretext:SetFont(f, 14)
	headerfiretext:SetWidth(30)
	headerfiretext:SetText(L["Fr"])
	headerfiretext:SetTextColor(1, 0, 0)
	headerfiretext:ClearAllPoints()
	headerfiretext:SetJustifyH("RIGHT")
	headerfiretext:SetAllPoints(headerfire)

	local headernature = CreateFrame("Button", nil, main)
	headernature:SetWidth(30)
	headernature:SetHeight(16)
	headernature:SetPoint("LEFT", headerfire, "RIGHT")
	headernature:SetScript("OnClick", function()
		self:Sort(resists, 3)
		self:UpdateScrollBar()
	end)

	local headernaturehigh = headernature:CreateTexture(nil, "BORDER")
	headernaturehigh:SetWidth(30)
	headernaturehigh:SetHeight(16)
	headernaturehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headernaturehigh:SetAllPoints(headernature)
	headernaturehigh:SetBlendMode("ADD")
	headernaturehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headernature:SetHighlightTexture(headernaturehigh)

	local headernaturetext = main:CreateFontString(nil,"OVERLAY")
	headernaturetext:SetFont(f, 14)
	headernaturetext:SetWidth(60)
	headernaturetext:SetText(L["N"])
	headernaturetext:SetTextColor(0, 1, 0)
	headernaturetext:ClearAllPoints()
	headernaturetext:SetJustifyH("RIGHT")
	headernaturetext:SetAllPoints(headernature)

	local headerfrost = CreateFrame("Button", nil, main)
	headerfrost:SetWidth(30)
	headerfrost:SetHeight(16)
	headerfrost:SetPoint("LEFT", headernature, "RIGHT")
	headerfrost:SetScript("OnClick", function()
		self:Sort(resists, 4)
		self:UpdateScrollBar()
	end)

	local headerfrosthigh = headerfrost:CreateTexture(nil, "BORDER")
	headerfrosthigh:SetWidth(30)
	headerfrosthigh:SetHeight(16)
	headerfrosthigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headerfrosthigh:SetAllPoints(headerfrost)
	headerfrosthigh:SetBlendMode("ADD")
	headerfrosthigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headerfrost:SetHighlightTexture(headerfrosthigh)

	local headerfrosttext = main:CreateFontString(nil,"OVERLAY")
	headerfrosttext:SetFont(f, 14)
	headerfrosttext:SetWidth(60)
	headerfrosttext:SetText(L["Ft"])
	headerfrosttext:SetTextColor(.5, .5, 1)
	headerfrosttext:ClearAllPoints()
	headerfrosttext:SetJustifyH("RIGHT")
	headerfrosttext:SetAllPoints(headerfrost)

	local headershadow = CreateFrame("Button", nil, main)
	headershadow:SetWidth(30)
	headershadow:SetHeight(16)
	headershadow:SetPoint("LEFT", headerfrost, "RIGHT")
	headershadow:SetScript("OnClick", function()
		self:Sort(resists, 5)
		self:UpdateScrollBar()
	end)

	local headershadowhigh = headershadow:CreateTexture(nil, "BORDER")
	headershadowhigh:SetWidth(30)
	headershadowhigh:SetHeight(16)
	headershadowhigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headershadowhigh:SetAllPoints(headershadow)
	headershadowhigh:SetBlendMode("ADD")
	headershadowhigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headershadow:SetHighlightTexture(headershadowhigh)

	local headershadowtext = main:CreateFontString(nil,"OVERLAY")
	headershadowtext:SetFont(f, 14)
	headershadowtext:SetWidth(60)
	headershadowtext:SetText(L["S"])
	headershadowtext:SetTextColor(.8, 0, 1)
	headershadowtext:ClearAllPoints()
	headershadowtext:SetJustifyH("RIGHT")
	headershadowtext:SetAllPoints(headershadow)

	local headerarcane = CreateFrame("Button", nil, main)
	headerarcane:SetWidth(30)
	headerarcane:SetHeight(16)
	headerarcane:SetPoint("LEFT", headershadow, "RIGHT")
	headerarcane:SetScript("OnClick", function()
		self:Sort(resists, 6)
		self:UpdateScrollBar()
	end)

	local headerarcanehigh = headerarcane:CreateTexture(nil, "BORDER")
	headerarcanehigh:SetWidth(30)
	headerarcanehigh:SetHeight(16)
	headerarcanehigh:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	headerarcanehigh:SetAllPoints(headerarcane)
	headerarcanehigh:SetBlendMode("ADD")
	headerarcanehigh:SetGradientAlpha("VERTICAL", .1, .08, 0, 0, .2, .16, 0, 1)
	headerarcane:SetHighlightTexture(headerarcanehigh)

	local headerarcanetext = main:CreateFontString(nil,"OVERLAY")
	headerarcanetext:SetFont(f, 14)
	headerarcanetext:SetWidth(60)
	headerarcanetext:SetText(L["A"])
	headerarcanetext:SetTextColor(1, 1, 1)
	headerarcanetext:ClearAllPoints()
	headerarcanetext:SetJustifyH("RIGHT")
	headerarcanetext:SetAllPoints(headerarcane)

	local leftbutton = CreateFrame("Button", nil, main)
	leftbutton:SetWidth(125)
	leftbutton:SetHeight(32)
	leftbutton:SetPoint("BOTTOMRIGHT", main, "BOTTOM", -10, 10)
	
	local t = leftbutton:CreateTexture()
	t:SetWidth(125)
	t:SetHeight(32)
	t:SetPoint("CENTER", leftbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	leftbutton:SetNormalTexture(t)

	t = leftbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(leftbutton)
	leftbutton:SetPushedTexture(t)
	
	t = leftbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(leftbutton)
	t:SetBlendMode("ADD")
	leftbutton:SetHighlightTexture(t)
	leftbuttontext = leftbutton:CreateFontString(nil,"OVERLAY")
	leftbuttontext:SetFontObject(GameFontHighlight)
	leftbuttontext:SetText(L["Refresh"])
	leftbuttontext:SetAllPoints(leftbutton)

	leftbutton:SetScript("OnClick", function()
		self:PerformResistanceCheck()
	end)

	local rightbutton = CreateFrame("Button", nil, main)

	rightbutton:SetWidth(125)
	rightbutton:SetHeight(32)
	rightbutton:SetPoint("BOTTOMLEFT", main, "BOTTOM", 10, 10)

	t = rightbutton:CreateTexture()
	t:SetWidth(125)
	t:SetHeight(32)
	t:SetPoint("CENTER", rightbutton, "CENTER")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Up")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	rightbutton:SetNormalTexture(t)

	t = rightbutton:CreateTexture(nil, "BACKGROUND")
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Down")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(rightbutton)
	rightbutton:SetPushedTexture(t)

	t = rightbutton:CreateTexture()
	t:SetTexture("Interface\\Buttons\\UI-Panel-Button-Highlight")
	t:SetTexCoord(0, 0.625, 0, 0.6875)
	t:SetAllPoints(rightbutton)
	t:SetBlendMode("ADD")	
	rightbutton:SetHighlightTexture(t)
	rightbuttontext = rightbutton:CreateFontString(nil,"OVERLAY")
	rightbuttontext:SetFontObject(GameFontHighlight)
	rightbuttontext:SetText(L["Close"])
	rightbuttontext:SetAllPoints(rightbutton)

	rightbutton:SetScript("OnClick", function()
		main:Hide()
	end)

	entry = {}
	entry[1] = self:ScrollEntryFrame()
	entry[1]:SetPoint("TOPLEFT", main, "TOPLEFT", 10, -55 )
	for i = 2, 15 do
		j = i - 1
		entry[i] = self:ScrollEntryFrame()
		entry[i]:SetPoint("TOPLEFT", entry[j], "BOTTOMLEFT")
	end

	local sframe = CreateFrame("ScrollFrame", "oRAResistScrollFrame", main, "FauxScrollFrameTemplate")
	sframe:SetParent(main)
	sframe:SetWidth(285)
	sframe:SetHeight(240)
	sframe:SetPoint("TOPLEFT", main, "TOPLEFT", 5, -55)

	local function updateScroll()
		self:UpdateScrollBar()
	end

	sframe:SetScript("OnVerticalScroll", function()
		FauxScrollFrame_OnVerticalScroll(16, updateScroll)
	end)

end

function mod:ScrollEntryFrame()
	local f = CreateFrame("Button", nil, frame )
	f:SetWidth(240)
	f:SetHeight(16)

	local textname = f:CreateFontString(nil,"ARTWORK")
	textname:SetFontObject(GameFontHighlight)
	textname:SetWidth(130)
	textname:SetHeight(16)
	textname:SetJustifyH("LEFT")
	textname:SetNonSpaceWrap(false)
	textname:ClearAllPoints()
	textname:SetPoint( "LEFT", f, "LEFT")
	textname:SetTextColor(1,1,1)
	textname:SetText("Name")

	local textfire = f:CreateFontString(nil,"ARTWORK")
	textfire:SetFontObject(GameFontHighlight)
	textfire:SetWidth(30)
	textfire:SetHeight(16)
	textfire:SetJustifyH("RIGHT")
	textfire:SetNonSpaceWrap(false)
	textfire:ClearAllPoints()
	textfire:SetPoint("LEFT", textname, "RIGHT")
	textfire:SetTextColor(1,0,0)
	textfire:SetText("12")

	local textnature = f:CreateFontString(nil,"ARTWORK")
	textnature:SetFontObject(GameFontHighlight)
	textnature:SetWidth(30)
	textnature:SetHeight(16)
	textnature:SetJustifyH("RIGHT")
	textnature:SetNonSpaceWrap(false)
	textnature:ClearAllPoints()
	textnature:SetPoint("LEFT", textfire, "RIGHT")
	textnature:SetTextColor(0,1,0)
	textnature:SetText("3")

	local textfrost = f:CreateFontString(nil,"ARTWORK")
	textfrost:SetFontObject(GameFontHighlight)
	textfrost:SetWidth(30)
	textfrost:SetHeight(16)
	textfrost:SetJustifyH("RIGHT")
	textfrost:SetNonSpaceWrap(false)
	textfrost:ClearAllPoints()
	textfrost:SetPoint("LEFT", textnature, "RIGHT")
	textfrost:SetTextColor(.5,.5,1)
	textfrost:SetText("3")

	local textshadow = f:CreateFontString(nil,"ARTWORK")
	textshadow:SetFontObject(GameFontHighlight)
	textshadow:SetWidth(30)
	textshadow:SetHeight(16)
	textshadow:SetJustifyH("RIGHT")
	textshadow:SetNonSpaceWrap(false)
	textshadow:ClearAllPoints()
	textshadow:SetPoint("LEFT", textfrost, "RIGHT")
	textshadow:SetTextColor(.8,0,1)
	textshadow:SetText("3")

	local textarcane = f:CreateFontString(nil,"ARTWORK")
	textarcane:SetFontObject(GameFontHighlight)
	textarcane:SetWidth(30)
	textarcane:SetHeight(16)
	textarcane:SetJustifyH("RIGHT")
	textarcane:SetNonSpaceWrap(false)
	textarcane:ClearAllPoints()
	textarcane:SetPoint("LEFT", textshadow, "RIGHT")
	textarcane:SetTextColor(1,1,1)
	textarcane:SetText("3")

	return f
end

local paintchips = nil
local RL = nil
function mod:UpdateScrollBar()
	self:SetupFrames()

	local entries = #resists
	FauxScrollFrame_Update(sframe, entries, 15, 16)

	if not paintchips then paintchips = AceLibrary("PaintChips-2.0") end
	if not RL then RL = AceLibrary("Roster-2.1") end

	for i = 1, 15 do
		j = i + FauxScrollFrame_GetOffset(sframe)

		if j <= entries then
			local class = RL:GetUnitObjectFromName(resists[j][1]).class
			entry[i].textname:SetText("|cff"..paintchips:GetHex(class)..resists[j][1].."|r")
			entry[i].textfire:SetText(resists[j][2])
			entry[i].textnature:SetText(resists[j][3])
			entry[i].textfrost:SetText(resists[j][4])
			entry[i].textshadow:SetText(resists[j][5])
			entry[i].textarcane:SetText(resists[j][6])
			entry[i]:Show()
		else
			entry[i]:Hide()
		end
	end

end

function mod:AddPlayer(nick, fire, nature, frost, shadow, arcane)
	local update
	for i = 1, 40, 1 do
		if resists[i] and resists[i][1] == nick then
			update = i
		end
	end
	if update then
		resists[update][2] = fire or 0
		resists[update][3] = nature or 0
		resists[update][4] = frost or 0
		resists[update][5] = shadow or 0
		resists[update][6] = arcane or 0
	else
		table.insert( resists, {nick, tonumber(fire), tonumber(nature), tonumber(frost), tonumber(shadow), tonumber(arcane)})
	end
end


----------------------
-- Command Handlers --
----------------------

function mod:PerformResistanceCheck()
	if not self:IsPromoted() then return end
	resists = nil
	resists = {}
	self:SendMessage("RSTC")

	self:SetupFrames()
	frame:Show()
	self:UpdateScrollBar()
end

function mod:Sort(tbl, sortBy)
	table.sort(tbl,
		function(t1, t2)
			if t1[sortBy] == t2[sortBy] then
				return t1[1] < t2[1]
			else
				return t1[sortBy] > t2[sortBy]
			end
		end
	)
end

